<?php
/**  ______ _                 _               _ ___
 *  |  ____| |               | |             | |__ \
 *  | |__  | |_   ___      __| |__   ___  ___| |  ) |
 *  |  __| | | | | \ \ /\ / /| '_ \ / _ \/ _ \ | / /
 *  | |    | | |_| |\ V  V / | | | |  __/  __/ |/ /_
 *  |_|    |_|\__, | \_/\_/  |_| |_|\___|\___|_|____|
 *             __/ |
 *            |___/
 *
 * Flywheel2: the inertia php framework
 *
 * @category	Flywheel2
 * @package		constants
 * @author		wakaba <wakabadou@gmail.com>
 * @copyright	2011- Wakabadou honpo (http://www.wakabadou.net/) / Project ICKX (https://ickx.jp/)
 * @license		http://opensource.org/licenses/MIT The MIT License MIT
 * @varsion		2.0.0
 */

namespace ickx\fw2\constants\prefectures;

/**
 * 日本国における地域情報を管理します。
 *
 * @category	Flywheel2
 * @package		constants
 * @author		wakaba <wakabadou@gmail.com>
 * @license		http://opensource.org/licenses/MIT The MIT License MIT
 * @varsion		2.0.0
 */
class PrefectureJp {
	/**
	 * @var	int	都道府県コード：北海道
	 * @static
	 */
	const HOKKAIDO	= 1;

	/**
	 * @var	int	都道府県コード：青森県
	 * @static
	 */
	const AOMORIKEN	= 2;

	/**
	 * @var	int	都道府県コード：岩手県
	 * @static
	 */
	const IWATE		= 3;

	/**
	 * @var	int	都道府県コード：宮城県
	 * @static
	 */
	const MIYAGI	= 4;

	/**
	 * @var	int	都道府県コード：秋田県
	 * @static
	 */
	const AKITA		= 5;


	/**
	 * @var	int	都道府県コード：山口県
	 * @static
	 */
	const YAMAGATA 	= 6;

	/**
	 * @var	int	都道府県コード：福島県
	 * @static
	 */
	const FUKUSHIMA	= 7;

	/**
	 * @var	int	都道府県コード：茨城県
	 * @static
	 */
	const IBARAKI	= 8;

	/**
	 * @var	int	都道府県コード：栃木県
	 * @static
	 */
	const TOCHIGI	= 9;

	/**
	 * @var	int	都道府県コード：群馬県
	 * @static
	 */
	const GUNMA		= 10;

	/**
	 * @var	int	都道府県コード：埼玉県
	 * @static
	 */
	const SAITAMA	= 11;

	/**
	 * @var	int	都道府県コード：千葉県
	 * @static
	 */
	const CHIBA		= 12;

	/**
	 * @var	int	都道府県コード：東京都
	 * @static
	 */
	const TOKYO		= 13;

	/**
	 * @var	int	都道府県コード：神奈川県
	 * @static
	 */
	const KANAGAWA 	= 14;

	/**
	 * @var	int	都道府県コード：新潟県
	 * @static
	 */
	const NIIGATA	= 15;

	/**
	 * @var	int	都道府県コード：富山県
	 * @static
	 */
	const TOYAMA	= 16;

	/**
	 * @var	int	都道府県コード：石川県
	 * @static
	 */
	const ISHIKAWA 	= 17;

	/**
	 * @var	int	都道府県コード：福井県
	 * @static
	 */
	const FUKUI		= 18;

	/**
	 * @var	int	都道府県コード：山梨県
	 * @static
	 */
	const YAMANASHI	= 19;

	/**
	 * @var	int	都道府県コード：長野県
	 * @static
	 */
	const NAGANO	= 20;

	/**
	 * @var	int	都道府県コード：岐阜県
	 * @static
	 */
	const GIFU 		= 21;

	/**
	 * @var	int	都道府県コード：静岡県
	 * @static
	 */
	const SHIZUOKA 	= 22;

	/**
	 * @var	int	都道府県コード：愛知県
	 * @static
	 */
	const AICHI		= 23;

	/**
	 * @var	int	都道府県コード：三重県
	 * @static
	 */
	const MIE		= 24;

	/**
	 * @var	int	都道府県コード：滋賀県
	 * @static
	 */
	const SHIGA		= 25;

	/**
	 * @var	int	都道府県コード：京都府
	 * @static
	 */
	const KYOTO		= 26;

	/**
	 * @var	int	都道府県コード：大阪府
	 * @static
	 */
	const OSAKA		= 27;

	/**
	 * @var	int	都道府県コード：兵庫県
	 * @static
	 */
	const HYOGO		= 28;

	/**
	 * @var	int	都道府県コード：奈良県
	 * @static
	 */
	const NARA 		= 29;

	/**
	 * @var	int	都道府県コード：和歌山県
	 * @static
	 */
	const WAKAYAMA 	= 30;

	/**
	 * @var	int	都道府県コード：鳥取県
	 * @static
	 */
	const TOTTORI	= 31;

	/**
	 * @var	int	都道府県コード：島根県
	 * @static
	 */
	const SHIMANE	= 32;

	/**
	 * @var	int	都道府県コード：岡山県
	 * @static
	 */
	const OKAYAMA	= 33;

	/**
	 * @var	int	都道府県コード：広島県
	 * @static
	 */
	const HIROSHIMA	= 34;

	/**
	 * @var	int	都道府県コード：山口県
	 * @static
	 */
	const YAMAGUCHI	= 35;

	/**
	 * @var	int	都道府県コード：徳島県
	 * @static
	 */
	const TOKUSHIMA	= 36;

	/**
	 * @var	int	都道府県コード：香川県
	 * @static
	 */
	const KAGAWA	= 37;

	/**
	 * @var	int	都道府県コード：愛媛県
	 * @static
	 */
	const EHIME		= 38;

	/**
	 * @var	int	都道府県コード：高知県
	 * @static
	 */
	const KOCHI		= 39;

	/**
	 * @var	int	都道府県コード：福岡県
	 * @static
	 */
	const FUKUOKA	= 40;

	/**
	 * @var	int	都道府県コード：佐賀県
	 * @static
	 */
	const SAGA 		= 41;

	/**
	 * @var	int	都道府県コード：長崎県
	 * @static
	 */
	const NAGASAKI 	= 42;

	/**
	 * @var	int	都道府県コード：熊本県
	 * @static
	 */
	const KUMAMOTO 	= 43;

	/**
	 * @var	int	都道府県コード：大分県
	 * @static
	 */
	const OITA 		= 44;

	/**
	 * @var	int	都道府県コード：宮崎県
	 * @static
	 */
	const MIYAZAKI 	= 45;

	/**
	 * @var	int	都道府県コード：鹿児島県
	 * @static
	 */
	const KAGOSHIMA	= 46;

	/**
	 * @var	int	都道府県コード：沖縄県
	 * @static
	 */
	const OKINAWA	= 47;

	/**
	 * 全ての都道府県コードのリストを返します。
	 *
	 * @return	array	都道府県コードのリスト
	 */
	public static function GetPrefectureCodes () {
		return [
			static::HOKKAIDO,
			static::AOMORIKEN,
			static::IWATE,
			static::MIYAGI,
			static::AKITA,
			static::YAMAGATA ,
			static::FUKUSHIMA,
			static::IBARAKI,
			static::TOCHIGI,
			static::GUNMA,
			static::SAITAMA,
			static::CHIBA,
			static::TOKYO,
			static::KANAGAWA ,
			static::NIIGATA,
			static::TOYAMA,
			static::ISHIKAWA ,
			static::FUKUI,
			static::YAMANASHI,
			static::NAGANO,
			static::GIFU ,
			static::SHIZUOKA ,
			static::AICHI,
			static::MIE,
			static::SHIGA,
			static::KYOTO,
			static::OSAKA,
			static::HYOGO,
			static::NARA ,
			static::WAKAYAMA ,
			static::TOTTORI,
			static::SHIMANE,
			static::OKAYAMA,
			static::HIROSHIMA,
			static::YAMAGUCHI,
			static::TOKUSHIMA,
			static::KAGAWA,
			static::EHIME,
			static::KOCHI,
			static::FUKUOKA,
			static::SAGA ,
			static::NAGASAKI ,
			static::KUMAMOTO ,
			static::OITA ,
			static::MIYAZAKI ,
			static::KAGOSHIMA,
			static::OKINAWA,
		];
	}

	/**
	 * 全ての都道府県名のリストを返します。
	 *
	 * @return	array	全ての都道府県名のリスト
	 */
	public static function GetPrefectures () {
		return [
			static::HOKKAIDO	=> '北海道',
			static::AOMORIKEN	=> '青森県',
			static::IWATE		=> '岩手県',
			static::MIYAGI		=> '宮城県',
			static::AKITA		=> '秋田県',
			static::YAMAGATA 	=> '山形県',
			static::FUKUSHIMA	=> '福島県',
			static::IBARAKI		=> '茨城県',
			static::TOCHIGI		=> '栃木県',
			static::GUNMA		=> '群馬県',
			static::SAITAMA		=> '埼玉県',
			static::CHIBA		=> '千葉県',
			static::TOKYO		=> '東京都',
			static::KANAGAWA 	=> '神奈川県',
			static::NIIGATA		=> '新潟県',
			static::TOYAMA		=> '富山県',
			static::ISHIKAWA 	=> '石川県',
			static::FUKUI		=> '福井県',
			static::YAMANASHI	=> '山梨県',
			static::NAGANO		=> '長野県',
			static::GIFU 		=> '岐阜県',
			static::SHIZUOKA 	=> '静岡県',
			static::AICHI		=> '愛知県',
			static::MIE			=> '三重県',
			static::SHIGA		=> '滋賀県',
			static::KYOTO		=> '京都府',
			static::OSAKA		=> '大阪府',
			static::HYOGO		=> '兵庫県',
			static::NARA 		=> '奈良県',
			static::WAKAYAMA 	=> '和歌山県',
			static::TOTTORI		=> '鳥取県',
			static::SHIMANE		=> '島根県',
			static::OKAYAMA		=> '岡山県',
			static::HIROSHIMA	=> '広島県',
			static::YAMAGUCHI	=> '山口県',
			static::TOKUSHIMA	=> '徳島県',
			static::KAGAWA		=> '香川県',
			static::EHIME		=> '愛媛県',
			static::KOCHI		=> '高知県',
			static::FUKUOKA		=> '福岡県',
			static::SAGA 		=> '佐賀県',
			static::NAGASAKI 	=> '長崎県',
			static::KUMAMOTO 	=> '熊本県',
			static::OITA 		=> '大分県',
			static::MIYAZAKI 	=> '宮崎県',
			static::KAGOSHIMA	=> '鹿児島県',
			static::OKINAWA		=> '沖縄県',
		];
	}

	/**
	 * 都道府県コードから都道府県名を返します。
	 *
	 * @param 	$search_cd 検索条件
	 * @return	全ての都道府県名のリスト
	 */
	public static function FindPrefectureNameByPrefectureCode ($pref_cd) {
		$prefecture_list = static::GetPrefectures();
		return isset($prefecture_list[$pref_cd]) ? $prefecture_list[$pref_cd] : '';
	}
}
